import { Route } from '@abearxiong/router';
import { router } from '../modules/router.ts';
import { getPackage, installPackage } from '../lib/npm.ts';

const install = new Route('admin', 'install');
install.run = async (ctx) => {
  const { packageName } = ctx.query;
  const data = await installPackage(packageName);
  ctx.body = data;
  return ctx;
};
install.validator = {
  packageName: {
    type: 'string',
    required: true,
  },
};
router.add(install);

const getNpm = new Route('admin', 'getNpm');
getNpm.run = async (ctx) => {
  const data = await getPackage();
  ctx.body = data['dependencies'];
  return ctx;
};
router.add(getNpm);
