import { QueryTypes } from 'sequelize';
import { sequelize } from '../../src/modules/index.ts';

const sleep = (ms: number) => new Promise((resolve) => setTimeout(resolve, ms));
// yarn test --testNamePattern='Sequelize'
describe('Hello Sequelize', () => {
  // 编写一个测试用例
  // yarn test --testNamePattern='Sequelize:connect success' 
  test('Sequelize:connect success', async () => {
    try {
      const auth = await sequelize.authenticate();
      console.log('connect success');
      await sleep(2000);
    } catch (error) {
      console.error('connect error', error);
    }
  });
  // yarn test --testNamePattern='Sequelize:queryTables' 
  test('Sequelize:queryTables', async () => {
    try {
      const tablesCount: any = await sequelize.query(
        "SELECT COUNT(*) AS table_count FROM information_schema.tables WHERE table_schema = 'public';",
        { type: QueryTypes.SELECT },
      );
      if (!tablesCount[0]) {
        console.error('未查询到表数量');
        return;
      }

      console.log('数据库中的表数量：', tablesCount[0].table_count);
      await sleep(2000);
    } catch (error) {
      console.error('查询表数量时出错：', error);
    }
  });
});
